/////////////////////////////////////////////////////////////////////////////
// Name:        windows.cpp
// Purpose:     common (to all ports) wxWindow functions
// Author:      Julian Smart, Vadim Zeitlin
// Modified by:
// Created:     13/07/98
// RCS-ID:      $Id: wincmn.cpp,v 1.5 1998/10/09 11:59:21 JS Exp $
// Copyright:   (c) Julian Smart and Markus Holzem
// Licence:     wxWindows license
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "wx/frame.h"
#include "wx/defs.h"
#include "wx/window.h"

// Do Update UI processing for child controls

// TODO: should this be implemented for the child window rather
// than the parent? Then you can override it e.g. for wxCheckBox
// to do the Right Thing rather than having to assume a fixed number
// of control classes.
#include "wx/checkbox.h"
#include "wx/radiobut.h"

void wxWindow::UpdateWindowUI()
{
  wxWindowID id = GetId();
  if (id > 0)
  {
    wxUpdateUIEvent event(id);
    event.m_eventObject = this;

    if (this->GetEventHandler()->ProcessEvent(event))
    {
      if (event.GetSetEnabled())
        this->Enable(event.GetEnabled());

      if (event.GetSetText() && this->IsKindOf(CLASSINFO(wxControl)))
        ((wxControl*)this)->SetLabel(event.GetText());

      if (this->IsKindOf(CLASSINFO(wxCheckBox)))
      {
        if (event.GetSetChecked())
          ((wxCheckBox *) this)->SetValue(event.GetChecked());
      }
      // @@@ No radio buttons in wxGTK yet
#ifndef __WXGTK__
      else if (this->IsKindOf(CLASSINFO(wxRadioButton)))
      {
        if (event.GetSetChecked())
          ((wxRadioButton *) this)->SetValue(event.GetChecked());
      }
#endif
    }
  }
}

// Dialog units translations. Implemented in wincmn.cpp.
wxPoint wxWindow::ConvertPixelsToDialog(const wxPoint& pt)
{
    int charWidth = GetCharWidth();
    int charHeight = GetCharHeight();
    wxPoint pt2;
    pt2.x = (int) ((pt.x * 4) / charWidth) ;
    pt2.y = (int) ((pt.y * 8) / charHeight) ;

    return pt2;
}

wxPoint wxWindow::ConvertDialogToPixels(const wxPoint& pt)
{
    int charWidth = GetCharWidth();
    int charHeight = GetCharHeight();
    wxPoint pt2;
    pt2.x = (int) ((pt.x * charWidth) / 4) ;
    pt2.y = (int) ((pt.y * charHeight) / 8) ;

    return pt2;
}

